common: replace chattr with $CHATTR_PROG
[xfstests-dev.git] / tests / xfs / 117
1 #! /bin/bash
2 # FS QA Test No. 117
3 #
4 # Create and populate an XFS filesystem, corrupt an inode, then see how
5 # the kernel and xfs_repair deal with it.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     #rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/attr
44 . ./common/populate
45
46 # real QA test starts here
47 _supported_fs xfs
48 _supported_os Linux
49
50 _require_scratch
51 test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
52 _require_attrs
53 _require_xfs_db_blocktrash_z_command
54 test -z "${FUZZ_ARGS}" && FUZZ_ARGS="-n 8 -3"
55
56 rm -f $seqres.full
57 TESTDIR="${SCRATCH_MNT}/scratchdir"
58 TESTFILE="${TESTDIR}/testfile"
59
60 echo "+ create scratch fs"
61 _scratch_mkfs_xfs > /dev/null
62
63 echo "+ mount fs image"
64 _scratch_mount
65 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
66
67 echo "+ make some files"
68 mkdir -p "${TESTDIR}"
69 for x in `seq 1 1024`; do
70         touch "${SCRATCH_MNT}/junk.${x}"
71         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
72         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
73                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
74                 break
75         fi
76 done
77 for x in `seq 2 64`; do
78         touch "${TESTFILE}.${x}"
79 done
80 inode="$(stat -c '%i' "${TESTFILE}.1")"
81 umount "${SCRATCH_MNT}"
82
83 echo "+ check fs"
84 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
85
86 echo "+ corrupt image"
87 seq "${inode}" "$((inode + 64))" | while read ino; do
88         $XFS_DB_PROG -x -c "inode ${ino}" -c "stack" -c "blocktrash -x 32 -y $((blksz * 8)) -z ${FUZZ_ARGS}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
89 done
90
91 echo "+ mount image"
92 _scratch_mount
93
94 echo "+ modify files"
95 broken=0
96 for x in `seq 1 64`; do
97         stat "${TESTFILE}.${x}" >> $seqres.full 2>&1
98         test $? -ne 0 && broken=1
99         touch "${TESTFILE}.${x}" >> $seqres.full 2>&1
100         test $? -ne 0 && broken=1
101 done
102 echo "broken: ${broken}"
103 umount "${SCRATCH_MNT}"
104
105 echo "+ repair fs"
106 _scratch_xfs_repair >> $seqres.full 2>&1
107
108 echo "+ mount image (2)"
109 _scratch_mount
110
111 echo "+ chattr -R -i"
112 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
113
114 echo "+ modify files (2)"
115 broken=0
116 for x in `seq 1 64`; do
117         test -e "${TESTFILE}.${x}" || continue
118         echo "test ${x}" >> $seqres.full
119         stat "${TESTFILE}.${x}" >> $seqres.full 2>&1
120         test $? -ne 0 && broken=1
121         touch "${TESTFILE}.${x}" >> $seqres.full 2>&1
122         test $? -ne 0 && broken=1
123         echo "${x}: broken=${broken}" >> $seqres.full
124 done
125 echo "broken: ${broken}"
126 umount "${SCRATCH_MNT}"
127
128 echo "+ check fs (2)"
129 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
130
131 status=0
132 exit